import com.nokia.mid.ui.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.*;
import java.util.*;

class ECanvas
    extends FullCanvas
    implements Runnable, CommandListener
{
    private volatile Thread animationThread = null;
    private Font font;
    testMIDlet father;
    int i=0;
    int stop=0,alpha=0,cnt;
    int pts[];
    int ptsc;
    int tri[];
    int tric;
    int pxyz[];
    Image parts[];
    long fp_time_start=0,fp_time;
    int  fps=0;
    String T;


    ECanvas()
    {
    }

    private int sin(int x)
    {
        int r=1;
 
        x%=360;

 	if (x>180) { x-=180; r=-1; }

	return r*(8100-(90-x)*(90-x))/252;
    }


    public void render(Graphics g)
    {
	int i,j,x,y,z,sa,ca;
	DirectGraphics dg=DirectUtils.getDirectGraphics(g);

        g.setColor(0,0,0);
	g.fillRect(0,0,63,127);
//        g.setColor(0xFF,0,0);
//	g.fillRect(0,20,10,80);
	
	sa=sin(alpha); ca=sin(alpha+90);

	for( i=0; i<ptsc; i++) {
	    pxyz[3*i+2]=z=(4096+(pts[3*i+2]*sa-pts[3*i+1]*ca))>>5;
	    pxyz[3*i+0]=(/*8192*/+pts[3*i+0]*z)>>7;
	    pxyz[3*i+1]=(0x40000+(pts[3*i+2]*ca+pts[3*i+1]*sa)*z)>>12;
	}
	for( i=0; i<tric; i++) {	    
	    dg.fillTriangle( pxyz[ 3*tri[3*i+0]], pxyz[ 3*tri[3*i+0]+1]-4,
			     pxyz[ 3*tri[3*i+1]], pxyz[ 3*tri[3*i+1]+1]-4,
			     pxyz[ 3*tri[3*i+2]], pxyz[ 3*tri[3*i+2]+1]-4, 0x000F6FFF+((pxyz[ 3*tri[3*i+0]+2]-74)<<25));
	}
    }

    public void paint(Graphics g)
    {
	DirectGraphics dg=DirectUtils.getDirectGraphics(g);
	int x,y;

	if (fp_time_start==0) {
	    g.setColor(0,0,0);
	    g.fillRect(0,0,127,127);
	    g.setColor(0xFF,0xFF,0xFF);
	    g.drawString("Part 1",40,60,0);
	    return;
	}
	
	cnt++;
	alpha=sin(cnt)+64;

	y=4096/cnt;
	if (y<4) y=4;
	y+=sin(cnt)*256/cnt;
	y+=stop; 
	x=64;
	if (stop>0) {
	    g.setColor(0,0,0);
	    g.fillRect( 0,0,128,4+y);
	    x=64+sin(stop++);
	}


	if ((alpha%20)<10) {
	    dg.drawImage( parts[alpha%10],   x, y,0,0x4000);
	    dg.drawImage( parts[alpha%10],  x-60, y,0,0x6000);
        } else {
	    dg.drawImage( parts[9-(alpha%10)],  x, y,0,0x0000);
	    dg.drawImage( parts[9-(alpha%10)], x-60, y,0,0x2000);
	}
    }

    public synchronized void start(testMIDlet papa)
    {
	int m,n,l;
 	Graphics gTo;
	
  	father=papa;

        font = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_SMALL);

	ptsc=18*24;
	pts=new int[3*ptsc];
	pxyz=new int[ptsc*3];
	for( n=0; n<24; n++) {
	    for( m=0; m<18; m++)  {
	       pts[ 54*n+3*m+0 ]= (sin((m*23)/2)*(128+sin(n*15+90)))/96;
	       pts[ 54*n+3*m+1 ]= (sin(90+(m*23)/2)*(128+sin(n*15+90)))/96;
	       pts[ 54*n+3*m+2 ]= sin(n*15)*2/3;
	    }
	}

	tric=4*18*12;
	tri=new int[tric*3];
	l=0;
	for( m=0; m<tric/2; m++,l++)  {
	    tri[ 3*l+0 ] = (m+0)%ptsc;
	    tri[ 3*l+1 ] = (m+1)%ptsc;
	    tri[ 3*l+2 ] = (m+18)%ptsc;
 	    if ( pts[3*tri[3*l+1]]==0) l--;
	}
	for( m=0; m<tric/2; m++,l++)  {
	    tri[ 3*l+0 ] = (m+0)%ptsc;
	    tri[ 3*l+1 ] = (m+1)%ptsc;
	    tri[ 3*l+2 ] = (m-17+ptsc)%ptsc;
 	    if ( pts[3*tri[3*l+1]]==0) l--;    
	}
	tric=l;
/*	gTo=background.getGraphics();
	for( m=0; m<64; m++) 
  	    for( n=0; n<64; n++) {
		l=(m*m+n*n)/8;
		l=155-4*l;
		if (l<0) l=0;
		gTo.setColor(l,0,0);
		gTo.drawLine(m,n+64,m,n+65);
		gTo.drawLine(m,63-n,m,64-n);
	    }*/
	parts=new Image[10];
	for( m=0; m<10; m++) {
	    parts[m]=Image.createImage(60,120);
   	    gTo=parts[m].getGraphics();
	    alpha=(36*m+18)/4;
	    render(gTo);
	}

	alpha=1;
        animationThread = new Thread(this);
        animationThread.start();
        fp_time_start=System.currentTimeMillis()-1;
    }


    public void run()
    {
        Thread currentThread = Thread.currentThread();

        try
        {
            while (currentThread == animationThread)
            {
                long startTime = System.currentTimeMillis();

                repaint(0, 0, getWidth(), getHeight());
                serviceRepaints();
                long timeTaken = System.currentTimeMillis() - startTime;
                if (timeTaken < 10)
                {
                    synchronized (this)
                    {
                        wait(10 - timeTaken);
                    }
                }
                else
                {
                    currentThread.yield();
                }
		if (stop>100) {
		    parts=null;
		    pxyz=null;
		    tri=null;
		    pts=null;
		    father.nextcanvas();
		    return;
		}
            }
        }
        catch (InterruptedException e)
        {
        }
    }

    public void keyPressed(int keyCode)
    {
	if (keyCode=='5')
	   stop=1;
    }

    public void commandAction(Command c, Displayable d)
    { //have to be with keyPressed.
    }

    public synchronized void stop()
    {
        animationThread = null;
    }
}
