import com.nokia.mid.ui.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.IOException;

class SkyCanvas
    extends FullCanvas
    implements Runnable, CommandListener
{
    private volatile Thread animationThread = null;
    private Font font;
    private testMIDlet papa;
    testMIDlet father;
    Image background, star;
    int fps=0;
    long fp_time_start=0,fp_time;
    int i = 1, stop=0, px[]=new int[9*9], py[]=new int [9*9];
    int sintab1[];
    int sintab2[];

    private int sin(int x)
    {
        int r=1;
 
        x%=360;

 	if (x>180) { x-=180; r=-1; }

	return r*(8100-(90-x)*(90-x))/253;
    }


    SkyCanvas(testMIDlet papa)
    {
	this.papa=papa;
    }

    int xp[]=new int[22];
    int yp[]=new int[22];

    public void paint(Graphics g)
    {
	int j,k,l,gc;
	int p1,p2;
	String T;
	DirectGraphics dg=DirectUtils.getDirectGraphics(g);


	if (fp_time_start==0) return;
	g.drawImage( background ,0,0, Graphics.TOP | Graphics.LEFT);

	for( j=0; j<9; j++)
  	    for( k=0; k<9; k++) {
		l=i+j+k;
		px[j+k*9]=28+j*8+sintab1[(l*3/2)%30]*j/16;
		py[j+k*9]=26+k*8+sintab2[((l-k-k+20)*3/2)%30 ]*j/16;
	    }
	if (stop>0) {
	    for( j=0; j<81; j++)
		py[j]-=(sin(2*stop+90)-32)*3;
	    stop++;
	}

	if (i<200) {
	    p1=0xAFFF0000;
	    p2=0xAFFFFFFF;
	} else if (i<251) {
	    j=(i-200)*5;
	    p1=0xAFFF0000 - 0x10000*j + 0x1*j;
	    p2=0xCFFFFFFF - 0x10100*j;
	} else {
	    p1=p2=0xCF0000FF;
	}

	xp[ 0]=px[ 0]; 	yp[ 0]=py[ 0];
	xp[ 1]=px[ 1]; 	yp[ 1]=py[ 1];
	xp[ 2]=px[ 2]; 	yp[ 2]=py[ 2];
	xp[ 3]=px[ 3]; 	yp[ 3]=py[ 3];
	xp[ 4]=px[ 4]; 	yp[ 4]=py[ 4];
	xp[ 5]=px[ 5]; 	yp[ 5]=py[ 5];
	xp[ 6]=px[ 6]; 	yp[ 6]=py[ 6];
	xp[ 7]=px[ 7]; 	yp[ 7]=py[ 7];
	xp[ 8]=px[ 8]; 	yp[ 8]=py[ 8];

	xp[ 9]=px[17]; 	yp[ 9]=py[17];
	xp[10]=px[26]; 	yp[10]=py[26];
	xp[11]=px[35]; 	yp[11]=py[35];

	xp[12]=px[44]; 	yp[12]=py[43];
	xp[13]=px[43]; 	yp[13]=py[43];
	xp[14]=px[42]; 	yp[14]=py[42];
	xp[15]=px[41]; 	yp[15]=py[41];
	xp[16]=px[40]; 	yp[16]=py[40];
	xp[17]=px[39]; 	yp[17]=py[39];
	xp[18]=px[38]; 	yp[18]=py[38];
	xp[19]=px[37]; 	yp[19]=py[37];
	xp[20]=px[36]; 	yp[20]=py[36];
 	dg.fillPolygon( xp, 0, yp, 0, 21, p2) ; /* 0x7FFFFFFF */

	xp[ 0]=px[72]; 	yp[ 0]=py[72];
	xp[ 1]=px[73]; 	yp[ 1]=py[73];
	xp[ 2]=px[74]; 	yp[ 2]=py[74];
	xp[ 3]=px[75]; 	yp[ 3]=py[75];
	xp[ 4]=px[76]; 	yp[ 4]=py[76];
	xp[ 5]=px[77]; 	yp[ 5]=py[77];
	xp[ 6]=px[78]; 	yp[ 6]=py[78];
	xp[ 7]=px[79]; 	yp[ 7]=py[79];
	xp[ 8]=px[80]; 	yp[ 8]=py[80];

	xp[ 9]=px[71]; 	yp[ 9]=py[71];
	xp[10]=px[62]; 	yp[10]=py[62];
	xp[11]=px[53]; 	yp[11]=py[53];
 	dg.fillPolygon( xp, 0, yp, 0, 21, p1) ; /* 0xAFFF0000 */

	k=(i-200)/6;
	if (k<0) k=0;
	if (k>12) k=12;
	switch (k) {
	   case 12: j=4+9*1; g.drawImage( star, px[j]-4, (py[j]+py[j+9])/2-4, 0);
	   case 11: j=4+9*7; g.drawImage( star, px[j]-4, (py[j]+py[j-9])/2-4, 0);
	   case 10: j=1+9*4; g.drawImage( star, (px[j]+px[j+1])/2-4, py[j]-4, 0);
	   case 9 : j=7+9*4; g.drawImage( star, (px[j]+px[j-1])/2-4, py[j]-4, 0);

	   case 8 : j=3+9*2; g.drawImage( star, px[j]-4, py[j]-4, 0);
	   case 7 : j=5+9*2; g.drawImage( star, px[j]-4, py[j]-4, 0);
	   case 6 : j=3+9*6; g.drawImage( star, px[j]-4, py[j]-4, 0);
	   case 5 : j=5+9*6; g.drawImage( star, px[j]-4, py[j]-4, 0);

	   case 4 : j=2+9*3; g.drawImage( star, px[j]-4, py[j]-4, 0);
	   case 3 : j=2+9*5; g.drawImage( star, px[j]-4, py[j]-4, 0);
	   case 2 : j=6+9*3; g.drawImage( star, px[j]-4, py[j]-4, 0);
	   case 1 : j=6+9*5; g.drawImage( star, px[j]-4, py[j]-4, 0);
	}

	if (i<51) {
	    xp[0]=i; xp[1]=128-i; xp[2]=128-i; xp[3]=i;
	    yp[0]=i; yp[1]=i;     yp[2]=128-i; yp[3]=128-i;
	    dg.fillPolygon( xp, 0, yp, 0, 4, 0xFF000000-i*0x5000000);
	}

	i++;
	if (i>1000) stop=1;

	g.setColor(255,255,255);
        fp_time=10000*++fps/(System.currentTimeMillis()-fp_time_start);
	T=String.valueOf(fp_time);
        g.drawString(T,105,101,0);
    }

    public synchronized void start(testMIDlet papa)
    {
	int i;
 	Graphics gTo;
	
  	father=papa;
        try
        {
            background   = Image.createImage("/bck.png");
            star         = Image.createImage("/star.png");
	}
        catch (IOException e)
        {
        }

	sintab1=new int[30];
	sintab2=new int[30];

	for(i=0;i<30;i++) {
	    sintab1[i]=sin(i*12);
	    sintab2[i]=sin(i*12+100);
	}



        fp_time_start=System.currentTimeMillis()-1;

        animationThread = new Thread(this);
        animationThread.start();
        font = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_SMALL);
    }


    public void run()
    {
        Thread currentThread = Thread.currentThread();

        try
        {
            // This ends when animationThread is set to null, or when
            // it is subsequently set to a new thread; either way, the
            // current thread should terminate
            while (currentThread == animationThread)
            {
                long startTime = System.currentTimeMillis();
                //tickBoids();
                repaint(0, 0, getWidth(), getHeight());
                serviceRepaints();
                long timeTaken = System.currentTimeMillis() - startTime;
                if (timeTaken < 1)
                {
                    synchronized (this)
                    {
                        wait(1 - timeTaken);
                    }
                }
                else
                {
                    currentThread.yield();
                }
		if (stop>50) {
		    sintab1=sintab2=px=py=xp=yp=null;
		    background=star=null;
		    font=null;
		    father.nextcanvas();
		    return;
		}
            }
        }
        catch (InterruptedException e)
        {
        }
    }

    public void keyPressed(int keyCode)
    {
	if (keyCode=='5')
	   stop=1;
    }

    public void commandAction(Command c, Displayable d)
    { //have to be with keyPressed.
    }

    public synchronized void stop()
    {
        animationThread = null;
    }
}
