import com.nokia.mid.ui.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.IOException;

class TestCanvas
    extends Canvas
    implements Runnable, CommandListener
{
    private volatile Thread animationThread = null;
    private Font font;
    private testMIDlet papa;
    private Image image[]={
Image.createImage(128,96),Image.createImage(128,96),Image.createImage(128,96),Image.createImage(128,96)
 };
    private Image ilist[] ;
    private Image ilist2[];
    int  i = 33, imok=0, fps=0;
    long fp_time_start,fp_time;
    int mapsize_x=10, mapsize_y=10;
    int pos_x=32*5, pos_y=32*5, pos_a=5, pos_z=32,fff=0;
    int map[]={ 
	0,0,0,2,2,1,1,0,0,0,
	0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,1,0,0,0,0,
	0,0,0,2,2,0,1,0,0,0,
	0,0,1,0,0,0,1,0,0,0,
	0,0,1,0,0,0,0,2,2,0,
	0,2,0,0,0,0,0,1,0,2,
	0,0,1,0,0,0,0,2,0,2,
	0,0,2,0,0,0,0,0,0,2,
	0,0,1,0,0,0,0,2,2,0 };
    final int map_x=10;
    final int map_y=10;
    int pixels_x[];//=new int[121];
    int pixels_y[];//=new int[121];
    int z_buf[];//=new int[128];
    int w_buf[];//=new int[128];
    int z_b_cnt=0;
    int zb_left=0, zn_left;
    int zb_right=128, zn_right;


    TestCanvas(testMIDlet papa)
    {
	this.papa=papa;
    }


    private int sin(int x)
    {
        int r=1;
 
        x%=360;

 	if (x>180) { x-=180; r=-1; }

	return r*(8100-(90-x)*(90-x))/253;
    }

    private boolean isin(int x,int min, int max)
    {
	return ((x>min)&&(x<max)) || ((x<min)&&(x>max));
    }

    private void push_z( int x0, int y0, int x1, int y1, int t) 
    {
        int i,dx,dy;
	long z;

	if (x0>x1) {
	    i=x1; x1=x0; x0=i;
	    i=y1; y1=y0; y0=i;
	}
	if (x1==x0) return;


	if (x0<0) {
	    z =-x0;
	    z*=(y1-y0);
	    z/=(x1-x0);
	    z+=y0;
	    y0=(int) z;
	    x0=0;
	}
	if (x1<=x0) return;

	dx=x1-x0;
	dy=y1-y0;
	if (x1>127)
	    x1=127;
	if (x0<=zb_left) {
	    x0=zb_left;
	    zn_left=x1;	    
	}
	if (x1>=zb_right) {
	    x1=zb_right;
	    zn_right=x0;
	}

	for( i=x0; i<=x1; i++) {
	    z=i-x0;
	    z*=dy;
	    z=z/dx+y0;
	    if (z_buf[i]<z) {
		if (z_buf[i]==0)
		    z_b_cnt++;
		z_buf[i]=(int) z;
		w_buf[i]=t;	
	    } else fff++;
	}
    }

    public void paint(Graphics g)
    {
	int sj,sk,j,k,x,y,ss,sc,sx,sy,px_i,im,p0,p1,p11,p12,k0,k1,k2,k3;
	String T;

	if (fp_time_start==0) {
	    g.setColor(0,0,0);
	    g.fillRect(0,0,127,127);
	    g.setColor(0xFF,0xFF,0xFF);
	    g.drawString("Part 4",40,60,0);
	    return;
	}

	if ((i-=4)<0) 
	    i=1440;
	
	pos_a=i+2*sin(i);
	pos_x=32*5+sin(2*i);
	pos_y=32*7+sin(90+2*i);
	pos_z=32-3*sin( (i/4)%180 )/4;
	ss=sin(pos_a);
	sc=sin(pos_a+90);

	for( j=-160-(pos_x%32),sj=-5; sj<6; j+=32,sj++) {
	    for( k=-160-(pos_y%32),sk=-5; sk<6; k+=32,sk++) {
		y= sc*j-ss*k;
		px_i=sj+5+(sk+5)*11;
		if (y<=0) {
		    pixels_y[px_i]=-1;
		    continue;
		}
	//	if ( isin(x,-7*y,7*y)) {		
		    pixels_x[px_i]=(ss*j+sc*k)*32 /y+32;
		    pixels_y[px_i]=65536/y;
	//	} else 
	//	    pixels_y[px_i]=-1;
	    }
        }
	for( j=0; j<64; j++)
	    z_buf[j]=0;

	z_b_cnt=zb_left=zn_left=0; zb_right=zn_right=127;
	k0=k1=k2=k3=sj=sk=0; 
	for( k0=0; k0<80; k0++) {
		if (z_b_cnt>62) 
		    break;
		px_i=sj+60+sk*11;
  	        if ( (pixels_y[px_i]>0) && (pixels_y[px_i+1]>0) && (pixels_y[px_i+11]>0) && (pixels_y[px_i+12]>0) ) {
		    x=((pos_x/32)+sj+map_x)%map_x;
		    y=((pos_y/32)+sk+map_y)%map_y;
		    if (map[x+10*y]>0) {
			if ((sk>=0) && (map[x+10* ((y-1+map_y)%map_y) ]==0))
			    push_z( pixels_x[px_i   ], pixels_y[px_i   ], pixels_x[px_i+ 1], pixels_y[px_i+ 1],map[x+10*y]);
			if ((sk<=0) && (map[x+10* ((y+1)%map_y) ]==0))
			    push_z( pixels_x[px_i+12], pixels_y[px_i+12], pixels_x[px_i+11], pixels_y[px_i+11],map[x+10*y]);
			if ((sj<=0) && (map[(x+1)%map_x+10*y ]==0))
			    push_z( pixels_x[px_i+12], pixels_y[px_i+12], pixels_x[px_i+ 1], pixels_y[px_i+ 1],map[x+10*y]);
			if ((sj>=0) && (map[(x-1+map_x)%map_x+10*y ]==0))
			    push_z( pixels_x[px_i   ], pixels_y[px_i   ], pixels_x[px_i+11], pixels_y[px_i+11],map[x+10*y]);
			zb_left=zn_left; zb_right=zn_right;
/*		    g.setColor(255,255,255);
		    g.drawLine( 2*pixels_x[px_i   ], 48+pixels_y[px_i   ]/2, 2*pixels_x[px_i+12], 48+pixels_y[px_i+12]/2);
		    g.drawLine( 2*pixels_x[px_i+1 ], 48+pixels_y[px_i +1]/2, 2*pixels_x[px_i+11], 48+pixels_y[px_i+11]/2);*/
		    }
		}

	    switch(k1) {
	        case 0: sj++; break;
	        case 1: sk++; break;
	        case 2: sj--; break;
	        case 3: sk--; break;
	    }
	    if (k2==0) {k2=++k3/2; k1=(k1+1)%4;} else k2--;	
        }
        g.drawImage( image[pos_z/10], 0,0, Graphics.TOP | Graphics.LEFT);
/*	for( j=0; j<16; j++) {
	    y=(pos_a+j*10)%360;
	    if (y>179) y=360-y;
	    g.setColor( y,y,y);
  	    g.fillArc( -64,-48,256,192,j*10,10);
	}*/
	for( j=0;j<64; j++) {
	    if ((y=z_buf[j])>0) {
	        if (y>77) y=77;
		if (w_buf[j]==1) 
	            g.drawImage( ilist[ y ], 2*j, 48-pos_z*y/32, Graphics.TOP | Graphics.HCENTER);
		else
	            g.drawImage( ilist2[ y ], 2*j, 48-pos_z*y/32, Graphics.TOP | Graphics.HCENTER);
	    }
	}

	g.setColor(255,255,255);
        fp_time=10000*++fps/(System.currentTimeMillis()-fp_time_start);
	T=String.valueOf(fp_time);
        g.drawString(T,105,80,0);
/*	T=String.valueOf(zb_right);
        g.drawString(T,70,60,0);  
*/
	
    }

    public synchronized void start()
    {
 	int n,m,p,k;
 	Graphics gTo,gg;
	DirectGraphics dg;

	pixels_x=new int[121];
	pixels_y=new int[121];
	z_buf   =new int[128];
	w_buf   =new int[128];
	ilist=new Image[80];
	ilist2=new Image[80];


        font = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_SMALL);


	for(n=0;n<79;n++) {
	    ilist[n]=Image.createImage(2,n+1);
	    ilist2[n]=Image.createImage(2,n+1);
	    gTo=ilist[n].getGraphics();
  	    for(m=0;m<n+1;m++) {
		p=m*256/(n+1);
		p=p*n/80;
	        gTo.setColor( p,3*n,255-p);
		gTo.drawLine( 0,m,1,m);
	    }
	    gTo=ilist2[n].getGraphics();
  	    for(m=0;m<n+1;m++) {
		p=m*512/(n+1);
		if (p>255) p=511-p;
		p=p*n/80;
	        gTo.setColor( 3*n,3*n, p);
		gTo.drawLine( 0,m,1,m);
	    }
	}

	k=3;
        gTo=image[k].getGraphics();
	gTo.setColor(0,0,0);
	gTo.fillRect(0,0,128,96);
	for(n=1;n<128;n++) 
	    for(m=0;m<64;m++) {
	        p=(64-n)*(64-n)/32 + (64-m)*(64-m)/2;
		p=122+(k<<4)-p/7;
		if (p<16) p=16;
		if (p>255) p=255;
		gTo.setColor(p,p-8,p-16);
		gTo.drawLine( n,32+m,n,32+m);
	    }
	gTo.setColor(128,128,128);
	gTo.drawString("by Jakub Trznadel", 5,10,0);
	gTo.setColor(0,0,0);
	gTo.drawString("by Jakub Trznadel", 6,11,0);
	
	for(k=0;k<3;k++) {
	    gg=image[k].getGraphics();
	    gg.drawImage( image[3],0,0, Graphics.TOP | Graphics.LEFT);
	    dg=DirectUtils.getDirectGraphics(gg);
	    dg.fillTriangle( 0,0, 128,0, 128,128, (3-k)*0x10000000);
	    dg.fillTriangle( 0,0, 0,128, 128,128, (3-k)*0x10000000);
	}


	imok=1;

        fp_time_start=System.currentTimeMillis()-1;
        animationThread = new Thread(this);
        animationThread.start();

    }


    public void run()
    {
        Thread currentThread = Thread.currentThread();

        try
        {
            // This ends when animationThread is set to null, or when
            // it is subsequently set to a new thread; either way, the
            // current thread should terminate
            while (currentThread == animationThread)
            {
                long startTime = System.currentTimeMillis();

                repaint(0, 0, 128, 96);
                serviceRepaints();
                long timeTaken = System.currentTimeMillis() - startTime;
                if (timeTaken < 1)
                {
                    synchronized (this)
                    {
                        wait(1 - timeTaken);
                    }
                }
                else
                {
                    currentThread.yield();
                }
            }
        }
        catch (InterruptedException e)
        {
        }
    }

    public void keyPressed(int keyCode)
    {
//	i=0;
    }

    public void commandAction(Command c, Displayable d)
    { //have to be with keyPressed.
    }
}
