import com.nokia.mid.ui.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.*;
import java.util.*;

class AutoCanvas
    extends FullCanvas
    implements Runnable, CommandListener
{
    private volatile Thread animationThread = null;
    private Font font;
    testMIDlet father;
    int i=0;
    int stop=0,alpha=360,cnt;
    int pts[];
    int ptsc;
    int tri[];
    int tric;
    int pxyz[];
    int road[], roadcnt, xadd[];
    Image parts[];
    long fp_time_start=0,fp_time;
    int  fps=0;
    int keyLeft, keyRight, xpos=64;
    int cnt_y=0, auto_vx=0, auto_vy=0, auto_x=0, auto_y=0, render_auto_x=0, camera_x=0;
    String T;


    AutoCanvas()
    {
    }

    private int sin(int x)
    {
        int r=1;
 
        x%=360;

 	if (x>180) { x-=180; r=-1; }

	return r*(8100-(90-x)*(90-x))/252;
    }

    int xp[]={ 0,127,98,30};
    int yp[]={ 127,127,64,64};

    int get_road_x( int yp )
    {
	int i;

	while (yp<0) yp+=road_length;

        yp%=road_length;
	for( i=0; i<roadcnt-1; i++)
	   if  ( (road[2*i]<=yp) && (road[2*i+2]>yp) ) {
	       return road[2*i+1]+(road[2*i+3]-road[2*i+1])*(yp-road[2*i])/(road[2*i+2]-road[2*i]);
	   }
	if (yp>520) {
	    return road[2*roadcnt-1]*(200-yp)/15;
	}

        return 0;	
    }

    int roadie[], road_length, roadtab[];

    void road_load()
    {
	int i;

	roadie=new int[road_length];

	for( i=0; i<road_length; i++) {
	    roadie[i]=get_road_x( i);
	}	
    }

    void roadtabprepare()
    {
	int i;
	roadtab=new int[30];

	for (i=0; i<30; i++)
	    roadtab[i]=((40-i)*(40-i))/2-50;//(1800-20*i)/(i+1)/4;
    }

    int onroad=1;

    public void render(Graphics g)
    {
	int i,j,x,y,z,sa,ca,temp;
	DirectGraphics dg=DirectUtils.getDirectGraphics(g);

        g.setColor(0,0,0);
	g.fillRect(0,0,128,63);
        g.setColor(25,28,21);
	g.fillRect(0,63,128,63);
	                                                                              
//	sa=2*sin(2*cnt+360)+4;
//	y=2*cnt+420;
	int shift_x=0;
        int angle_road=0;//car_x-camera_x;                
                                                         
	for( i=0; i<30; i++) {                        //(31-i)*(31-i)
	    xadd[i]=64+((32+i)*(roadie[( (roadtab[i]+cnt)/4)%road_length ]-camera_x)+(angle_road*(i-28)))/32; 
	}

	render_auto_x=32+15*(car_x-camera_x);

	i=car_x-roadie[ ((2+cnt)/4) %road_length];

	if ( (i>64)|| (i<-64) )
	    onroad=1; 
	else 
	    onroad=8;

//	g.setColor( 0xA0,0x30,0x30);

	for( i=0; i<30; i++) {
	    x=xadd[i];
	    j=30*((cnt/8)%6) +i;
	    g.drawImage(  parts[ j], x,60+2*i, Graphics.TOP | Graphics.LEFT);
	    dg.drawImage( parts[ j], x-parts[j].getWidth(),60+2*i, 0, 0x2000);
/*	    g.drawLine( 60+x-parts[j].getWidth(), 60+2*i, 60+x-parts[j].getWidth(), 60+i);
	    g.drawLine( 60+x+parts[j].getWidth(), 60+2*i, 60+x+parts[j].getWidth(), 60+i);
	    g.drawLine( 61+x+parts[j].getWidth(), 60+2*i, 61+x+parts[j].getWidth(), 60+i);*/
	}

	sa=sin(alpha+angle_road/3); ca=sin(alpha+angle_road/3+90);

	for( i=0; i<ptsc; i++) {
	    pxyz[3*i+2]=z=(8192+(pts[3*i+2]*sa-(pts[3*i+0])*ca))>>6;
	    pxyz[3*i+1]=64-(((256*(pts[3*i+1]-64))/z)>>2);
	    pxyz[3*i+0]=64+((pts[3*i+2]*ca+(pts[3*i+0])*sa+render_auto_x)*4/z);
	}

// 	dg.fillPolygon( xp, 0, yp, 0, 4, 0xFF505050) ; /* 0x7FFFFFFF */

	for( i=0; i<tric; i++) {	    
	    dg.fillTriangle( pxyz[ 3*tri[3*i+0]], pxyz[ 3*tri[3*i+0]+1]-4,
			     pxyz[ 3*tri[3*i+1]], pxyz[ 3*tri[3*i+1]+1]-4,
			     pxyz[ 3*tri[3*i+2]], pxyz[ 3*tri[3*i+2]+1]-4, 0xFFFF6F00-((pxyz[ 3*tri[3*i+0]+2]/2)<<24));
	}

    }

  
    int angle_car=0, angle_wheels_for_car=720, angle_wheels;
    int v_car_front_wheels_from_speed, v_car_back_wheels_from_speed, car_x=0, car_y=0, car_vx=0, car_vy=0, car_ax=0, car_ay=0, car_v=12, k=16, Motor=16;
    int Ffront1x, Fback1x, Ffront1y, Fback1y;
  
    int abs( int x)
   {
	return (x>0)?x:-x;
    }

    int sgn( int x)
    {
	return (x>0)?1:-1;
    }

    int cos(int x)
    {
	return sin(x+90);
    }
    
    int a_speed=0;

    public void mechanics()
    {
	a_speed=(a_speed+4*(keyLeft-keyRight))*3/4;
	angle_wheels_for_car= ((a_speed+angle_wheels_for_car+2*(keyLeft-keyRight)))/**7/8*/;
	if (angle_wheels_for_car<0) angle_wheels_for_car+=360;
	angle_wheels=angle_wheels_for_car+angle_car;

	while (car_y<0) car_y+=130*4*16;
	if (car_x<-128*4) car_x+=128*4;
	if (car_x>128*256) car_x-=128*256;

  	camera_x=(car_x+8*camera_x)/9;

//	System.err.println( "vy=" + car_vy +" ay=" + car_ay );

	alpha=90+angle_wheels;

	car_vx=car_v*(2*sin(alpha-90)+onroad*car_vx)/160;
	car_vy=car_v*(2*sin(alpha)+onroad*car_vy)/160;

	car_x-=car_vx;
 	cnt  +=car_vy;
    }


    public void paint(Graphics g)
    {
	if (fp_time_start==0)
	    return;

	mechanics();
	render(g);

        fp_time=100000*++fps/(System.currentTimeMillis()-fp_time_start);
        g.drawString("fps="+fp_time/100+"."+fp_time%100,35,111,0);
    }

    public synchronized void start(testMIDlet papa)
    {
	int m,x,y,X,Y,k,mx;
 	Graphics gTo;
        InputStream IStr;	
	byte b[]=new byte[576];

  	father=papa;

        font = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_SMALL);

	pts =new int[3*(ptsc=12)];
	pxyz=new int[3*ptsc];
	tri=new int[ (tric=18)*3];
	pts[0*3+0]= 20; pts[0*3+1]=  8; pts[0*3+2]=-30;
	pts[1*3+0]=-20; pts[1*3+1]=  8; pts[1*3+2]=-30;
	pts[2*3+0]= 20; pts[2*3+1]=- 8; pts[2*3+2]=-30;
	pts[3*3+0]=-20; pts[3*3+1]=- 8; pts[3*3+2]=-30;
	pts[4*3+0]= 20; pts[4*3+1]=- 8; pts[4*3+2]=30;
	pts[5*3+0]=-20; pts[5*3+1]=- 8; pts[5*3+2]=30;
	pts[6*3+0]= 20; pts[6*3+1]=  8; pts[6*3+2]=30;
	pts[7*3+0]=-20; pts[7*3+1]=  8; pts[7*3+2]=30;

	pts[8*3+0]= 16; pts[8*3+1]= 24; pts[8*3+2]=-25;
	pts[9*3+0]=-16; pts[9*3+1]= 24; pts[9*3+2]=-25;
	pts[10*3+0]= 16; pts[10*3+1]= 24; pts[10*3+2]=10;
	pts[11*3+0]=-16; pts[11*3+1]= 24; pts[11*3+2]=10;

	tri[0*3+0]=0; tri[0*3+1]=1; tri[0*3+2]=2; 
	tri[1*3+0]=1; tri[1*3+1]=2; tri[1*3+2]=3; 
	tri[2*3+0]=2; tri[2*3+1]=3; tri[2*3+2]=4; 
	tri[3*3+0]=3; tri[3*3+1]=4; tri[3*3+2]=5; 

	tri[4*3+0]=4; tri[4*3+1]=5; tri[4*3+2]=6; 
	tri[5*3+0]=5; tri[5*3+1]=6; tri[5*3+2]=7; 
	tri[6*3+0]=4; tri[6*3+1]=6; tri[6*3+2]=0; 
	tri[7*3+0]=4; tri[7*3+1]=2; tri[7*3+2]=0; 

	tri[8*3+0]=5; tri[8*3+1]=7; tri[8*3+2]=1; 
	tri[9*3+0]=5; tri[9*3+1]=3; tri[9*3+2]=1; 

	tri[10*3+0]=8; tri[10*3+1]=0; tri[10*3+2]=1; 
	tri[11*3+0]=8; tri[11*3+1]=9; tri[11*3+2]=1; 
	tri[12*3+0]= 8; tri[12*3+1]= 9; tri[12*3+2]=10; 
	tri[13*3+0]= 8; tri[13*3+1]=10; tri[13*3+2]=11; 

	tri[14*3+0]=10; tri[14*3+1]=11; tri[14*3+2]= 6; 
	tri[15*3+0]=11; tri[15*3+1]= 6; tri[15*3+2]= 7; 

	tri[16*3+0]= 6; tri[16*3+1]= 0; tri[16*3+2]=10; 
	tri[17*3+0]= 7; tri[17*3+1]= 1; tri[17*3+2]=11; 
	for( m=0; m<ptsc; m++)
	    pts[3*m+1]-=30;

/*	gTo=background.getGraphics();
	for( m=0; m<64; m++) 
  	    for( n=0; n<64; n++) {
		l=(m*m+n*n)/8;
		l=155-4*l;
		if (l<0) l=0;
		gTo.setColor(l,0,0);
		gTo.drawLine(m,n+64,m,n+65);
		gTo.drawLine(m,63-n,m,64-n);
	    }*/
/*	parts=new Image[10];
	for( m=0; m<10; m++) {
	    parts[m]=Image.createImage(60,120);
   	    gTo=parts[m].getGraphics();
	    alpha=(36*m+18)/4;
	    render(gTo);
	}
*/
	IStr= getClass().getResourceAsStream("gnd.dat");
        try { IStr.read(b); } catch (IOException e) { }

	parts = new Image[12*30];

	for( m=0; m<12; m++) {
	    for( y=0; y<60; y++) {
		mx=6*y/5+20;
		if ((y&1)==0)
	            parts[m*30+(y/2)]=Image.createImage(mx,2);
   	        gTo=parts[m*30+(y/2)].getGraphics();	    
		
	        for( x=0; x<mx; x++) {
		    Y=(60-y)*160/(60+y)+m*4;
		    X=80*(x+4)/(20+y);    
		    if (X<48*2) {
		    X%=48; Y%=48;
		    k=b[X/4+Y*12]; if (k<0) k=256+k;
		    k=(k>>((X%4)*2))&3;
		    switch (k) {
			case 0:	gTo.setColor(  50*(y+30)/70, 55*(y+30)/70, 43*(y+30)/70); break;
			case 1:	gTo.setColor( 114*(y+30)/70,105*(y+30)/70, 77*(y+30)/70); break;
			case 2:	gTo.setColor( 140*(y+30)/70,127*(y+30)/70, 95*(y+30)/70); break;
			case 3:	gTo.setColor(  90*(y+30)/70, 87*(y+30)/70, 63*(y+30)/70); break;
		    } } else gTo.setColor(  0, 0, 0);
		   
//		   if ((X<3)||(Y<3)) k=0xFF;
//		    gTo.setColor( k,k,k);
		    gTo.drawLine( x,y&1,x,(y&1)+1);
		}
	    }
	}

	roadcnt=16; road=new int[roadcnt*2];
	m=0;
        road[m++]= 0; road[m++]= 0;
        road[m++]=20; road[m++]= 0;
        road[m++]=40; road[m++]= 0;
        road[m++]=60; road[m++]= 0;

        road[m++]=160; road[m++]=0;
        road[m++]=180; road[m++]=0;
        road[m++]=250; road[m++]=0;
        road[m++]=260; road[m++]=0;

        road[m++]=300; road[m++]=0;
        road[m++]=310; road[m++]=0;
        road[m++]=500; road[m++]=0;
        road[m++]=1000; road[m++]=500;

        road[m++]=1500; road[m++]= 0;
        road[m++]=1505; road[m++]= 0;
        road[m++]=1510; road[m++]=0;
        road[m++]=1520; road[m++]=0;

	road_length=1520;
	road_load();
	roadtabprepare();

	xadd=new int[30];

	alpha=1;
        animationThread = new Thread(this);
        animationThread.start();
        fp_time_start=System.currentTimeMillis()-1;
    }


    public void run()
    {
        Thread currentThread = Thread.currentThread();

        try
        {
            while (currentThread == animationThread)
            {
                long startTime = System.currentTimeMillis();

                repaint(0, 0, getWidth(), getHeight());
                serviceRepaints();
                long timeTaken = System.currentTimeMillis() - startTime;
                if (timeTaken < 91)
                {
                    synchronized (this)
                    {
                        wait(91 - timeTaken);
                    }
                }
                else
                {
                    currentThread.yield();
                }
		if (stop>0) {
		    parts=null;
		    pxyz=null;
		    tri=null;
		    pts=null;
		    father.nextcanvas();
		    return;
		}
            }
        }
        catch (InterruptedException e)
        {
        }
    }

    public void keyReleased(int keyCode)
    {
	switch (keyCode) {
	   case '4': keyLeft=0; break;
	   case '6': keyRight=0; break;
	}
    }


    public void keyPressed(int keyCode)
    {
	switch (keyCode) {
	   case '5': stop=1; break;
	   case '4': keyLeft=1; break;
	   case '6': keyRight=1; break;
	   case '2': car_v++; break;
	   case '8': car_v--; break;
	}
    }

    public void commandAction(Command c, Displayable d)
    { //have to be with keyPressed.
    }

    public synchronized void stop()
    {
        animationThread = null;
    }
}
